﻿namespace DataModel
{
  using System;
  using System.Security.Principal;
  using System.Threading;

  class GenericPrincipalScope: IDisposable
  {
    private IPrincipal oldPrincipal;

    public GenericPrincipalScope(string name, string[] roles)
    {
      this.oldPrincipal = Thread.CurrentPrincipal;
      Thread.CurrentPrincipal = new GenericPrincipal(new GenericIdentity(name), roles);
    }

    public void Dispose()
    {
      Thread.CurrentPrincipal = this.oldPrincipal;
    }
  }
}
