﻿namespace DataModel
{
  using System.ComponentModel;
  using System.ComponentModel.DataAnnotations;
  using Properties;
  using Unleashed.DataAnnotations;

  [MetadataType(typeof(Metadata))]
  partial class Product
  {

    // TODO: This breaks Product Insert page. Investigate
    [CustomProperty(Expression = "Supplier.Country")]
    //[UIHint("Parent", null, "ForeignKeyField", "Supplier", "DisplayField", "Country")]
    //[FilterUIHint("Parent", null, "ForeignKeyField", "Supplier", "DisplayField", "Country")]
    [Display(Order = 20)]
    public string Country
    {
      get { return this.Supplier.Country; }
    }

    [Authorization(
      Allow.Roles, "Manager",
      Allow.Users, "*", Actions.Read,
      Deny.Users, "*")]
    private abstract class Metadata
    {
      //[FilterUIHint("Text", null, "Columns", 40)]
      [Display(ResourceType = typeof(Resources), Name = "ProductNameDisplayName", Order = 10)]
      [Required(ErrorMessageResourceType = typeof(Resources), ErrorMessageResourceName = "ProductNameRequiredErrorMessage")]
      [StringLength(40, MinimumLength = 2)]
      public object ProductName { get; set; }

      [Display(Name = "Qty per Unit")]
      public object QuantityPerUnit { get; set; }

      [Required]
      [Range(0, int.MaxValue, ErrorMessage = "Unit Price must be greater than 0")]
      [Display(Name = "Unit Price")]
      [DataType(DataType.Currency)]
      public object UnitPrice { get; set; }

      [Display(Name = "Units in Stock")]
      [DefaultValue(0)]
      [Range(0, int.MaxValue, ErrorMessage = "Units in Stock must be greater than 0")]
      public object UnitsInStock { get; set; }

      [Display(Name = "Units On Order")]
      public object UnitsOnOrder { get; set; }

      [Display(Name = "Reorder Level")]
      public object ReorderLevel { get; set; }

      [Display(Name = "Order Items")]
      public object Order_Details { get; set; }
    }
  }
}
