﻿CREATE PROCEDURE [dbo].[Products_Update]
	@ProductID int, @RowsAffected int out,

  @OldProductName nvarchar(40), @OldSupplierID int, @OldCategoryID int, 
  @OldQuantityPerUnit nvarchar(20), @OldUnitPrice money, 
  @OldUnitsInStock smallint, @OldUnitsOnOrder smallint, 
  @OldReorderLevel smallint, @OldDiscontinued bit,

  @NewProductName nvarchar(40), @NewSupplierID int, @NewCategoryID int, 
  @NewQuantityPerUnit nvarchar(20), @NewUnitPrice money, 
  @NewUnitsInStock smallint, @NewUnitsOnOrder smallint, 
  @NewReorderLevel smallint, @NewDiscontinued bit
AS
BEGIN
  UPDATE Products SET 
    ProductName = @NewProductName,
    SupplierID = @NewSupplierID,
    CategoryID = @NewCategoryID,
    QuantityPerUnit = @NewQuantityPerUnit,
    UnitPrice = @NewUnitPrice,
    UnitsInStock = @NewUnitsInStock,
    UnitsOnOrder = @NewUnitsOnOrder,
    ReorderLevel = @NewReorderLevel, 
    Discontinued = @NewDiscontinued
  WHERE
    ProductID = @ProductID AND
    SupplierID = @OldSupplierID AND
    CategoryID = @OldCategoryID AND
    QuantityPerUnit = @OldQuantityPerUnit AND
    UnitPrice = @OldUnitPrice AND
    UnitsInStock = @OldUnitsInStock AND
    UnitsOnOrder = @OldUnitsOnOrder AND
    ReorderLevel = @OldReorderLevel AND 
    Discontinued = @OldDiscontinued;

  SET @RowsAffected = @@ROWCOUNT;
END