﻿CREATE TRIGGER [Order_CheckOutOfStockProducts]
  ON [dbo].[Orders] FOR INSERT, UPDATE AS 
BEGIN
  SET NOCOUNT ON;

  DECLARE @productName NVARCHAR(50);

  SELECT @productName = product.ProductName 
  FROM [Order Details] AS item 
  JOIN inserted ON item.OrderID = inserted.OrderID
  JOIN Products AS product ON item.ProductID = product.ProductID
  WHERE inserted.OrderStatus = 1
    AND product.UnitsInStock < item.Quantity;

  IF @productName <> null
  BEGIN
    DECLARE @errorMessage NVARCHAR(MAX) = @productName + ' is out of stock';
    RAISERROR (@errorMessage, 11, 0);
  END;
END;