﻿// Copyright © Microsoft Corporation.  All Rights Reserved.
// This code released under the terms of the 
// Microsoft Public License (MS-PL, http://opensource.org/licenses/ms-pl.html.)

namespace System.Linq.Dynamic
{
  public sealed class ParseException : Exception
  {
    private int position;

    public ParseException(string message, int position)
      : base(message)
    {
      this.position = position;
    }

    public int Position
    {
      get { return position; }
    }

    public override string ToString()
    {
      return string.Format(Res.ParseExceptionFormat, Message, position);
    }
  }
}
