namespace Unleashed.DynamicData
{
  using System.Linq;
  using System.Web.DynamicData;
  using Unleashed.DataAnnotations;

  public class UnleashedField : DynamicField
  {
    public override string SortExpression
    {
      get
      {
        object obj = this.ViewState["SortExpression"];
        if (obj != null) return (string)obj;

        if (this.Column != null)
        {
          CustomPropertyAttribute customProperty = this.Column.Attributes.OfType<CustomPropertyAttribute>().FirstOrDefault();
          if (customProperty != null && !string.IsNullOrEmpty(customProperty.Expression))
            return customProperty.Expression;

          return this.Column.SortExpression;
        }

        return string.Empty;
      }

      set { base.SortExpression = value; }
    }

    protected override DynamicControl CreateDynamicControl()
    {
      return new UnleashedControl();
    }
  }
}