namespace Unleashed.DynamicData
{
  using System.Web.DynamicData;
  using System.Web.UI.WebControls;

  public class UnleashedFieldGenerator: DefaultAutoFieldGenerator
  {
    public UnleashedFieldGenerator(MetaTable table): base(table)
    {      
    }

    protected override DynamicField CreateField(MetaColumn column, ContainerType containerType, DataBoundControlMode mode)
    {
      var field = new UnleashedField();
      field.DataField = column.Name;
      if (containerType == ContainerType.List) // in GridView
        field.HeaderText = column.ShortDisplayName;
      else // in DetailsView
        field.HeaderText = column.Prompt ?? column.DisplayName; 

      // Turn wrapping off by default so that error messages don't show up on the next line. 
      field.ItemStyle.Wrap = false;

      return field; 
    }
  }
}