namespace Unleashed.DynamicData
{
  using System.Linq;
  using System.Web.UI;
  using System.Web.UI.WebControls;
  using System.Web.UI.WebControls.Expressions;

  public class UnleashedFilterExpression : DataSourceExpression
  {
    private IUnleashedFilterProvider filter;

    public string ControlID { get; set; }

    public override void SetContext(Control owner, System.Web.HttpContext context, IQueryableDataSource dataSource)
    {
      base.SetContext(owner, context, dataSource);
      this.filter = (IUnleashedFilterProvider)this.FindControl(owner);
      this.filter.DataSource = dataSource;
    }

    public override IQueryable GetQueryable(IQueryable source)
    {
      return this.filter.GetQueryable(source);
    }

    private Control FindControl(Control owner)
    {
      Control container = owner.NamingContainer;
      while (container != null && container != owner.Page)
      {
        Control control = container.FindControl(this.ControlID);
        if (control != null) return control;
        container = container.NamingContainer;
      }

      return null;
    }
  }
}