namespace Unleashed.DynamicData
{
  using System.Reflection;
  using System.Web;
  using System.Web.DynamicData;
  using System.Web.UI.WebControls;

  public abstract class UnleashedFilterTemplate : QueryableFilterUserControl
  {
    private static readonly MethodInfo initializeMethod = typeof(QueryableFilterUserControl).GetMethod("Initialize", BindingFlags.Instance | BindingFlags.NonPublic);
    private static readonly PropertyInfo dataSourceProperty = typeof(QueryableFilterUserControl).GetProperty("QueryableDataSource", BindingFlags.Instance | BindingFlags.NonPublic);

    public MetaForeignKeyColumn ForeignKeyColumn
    {
      get { return (MetaForeignKeyColumn)this.Column; }
    }

    protected IQueryableDataSource DataSource
    {
      get { return (IQueryableDataSource)dataSourceProperty.GetValue(this, null); }
    }

    internal void Initialize(MetaColumn metaColumn, IQueryableDataSource dataSource, HttpContextBase httpContext)
    {
      initializeMethod.Invoke(this, new object[] { metaColumn, dataSource, httpContext });
    }
  }
}