namespace Unleashed.EntityFramework
{
  using System;
  using System.Data.Common;
  using System.Linq.Expressions;

  public static class DbDataRecordExtensions
  {
    public static T Get<T>(this DbDataRecord record, Expression<Func<T>> property)
    {
      string propertyName = ((MemberExpression)property.Body).Member.Name;
      object value = record[propertyName];
      if (value == DBNull.Value)
        return default(T);
      else
        return (T)value;
    }
  }
}
