﻿<%@ Page Language="C#" 
  MasterPageFile="~/Site.master" CodeBehind="Details.aspx.cs"
  Inherits="WebApplication.DynamicData.CustomPages.Orders.Details" %>

<asp:Content ContentPlaceHolderID="main" runat="Server">
  <asp:DynamicDataManager runat="server">
    <DataControls>
      <asp:DataControlReference ControlID="formView" />
    </DataControls>
  </asp:DynamicDataManager>

  <table>
  <tr valign="top">
    <td>
      <h2>Entry from table <%= ordersTable.DisplayName %></h2>
      <asp:FormView runat="server" ID="formView" DataSourceID="formDataSource">
        <ItemTemplate>
          <asp:DynamicEntity runat="server" />
          <div class="DDFormActions">
            <asp:DynamicHyperLink runat="server" Action="Edit" Text="Edit" />
            <asp:DynamicHyperLink runat="server" Action="Delete" Text="Delete" />
            <asp:DynamicHyperLink runat="server" Action="List" Text="Show all items"/>            
          </div>
        </ItemTemplate>
      </asp:FormView>

      <asp:EntityDataSource ID="formDataSource" runat="server" OnQueryCreated="FormDataSource_QueryCreated"/>
      <asp:QueryExtender TargetControlID="formDataSource" runat="server">
        <asp:DynamicRouteExpression />
      </asp:QueryExtender>
    </td>

    <td>
      <h2><%= itemsTable.DisplayName %></h2>
      <asp:GridView ID="gridView" runat="server" DataSourceID="gridDataSource" 
        AutogenerateColumns="False" AllowSorting="True">
        <Columns>
          <asp:DynamicField DataField="Product" />
          <asp:DynamicField DataField="UnitPrice" ItemStyle-HorizontalAlign="Right" />
          <asp:DynamicField DataField="Quantity" ItemStyle-HorizontalAlign="Right" />
          <asp:TemplateField>
            <ItemTemplate>
              <asp:DynamicHyperLink runat="server" Action="Edit" Text="Edit" />
              <asp:DynamicHyperLink runat="server" Action="Delete" Text="Delete" />
              <asp:DynamicHyperLink runat="server" Action="Details" Text="Details" />
            </ItemTemplate>
          </asp:TemplateField>
        </Columns>
      </asp:GridView>

      <asp:EntityDataSource ID="gridDataSource" runat="server" 
        ConnectionString="name=NorthwindEntities" DefaultContainerName="NorthwindEntities"
        EntitySetName="Order_Details" Include="Product"
        OnSelected="GridDataSource_Selected" />
      <asp:QueryExtender TargetControlID="gridDataSource" runat="server">
        <asp:DynamicRouteExpression />
      </asp:QueryExtender>

      <br />
      <div class="DD">
        Total: <asp:Literal ID="totalLiteral" runat="server"/>
      </div>
    </td>
  </tr>
  </table>   
</asp:Content>
