﻿
namespace WebApplication.DynamicData.CustomPages.Orders
{
  using System;
  using System.Collections.Generic;
  using System.Linq;
  using System.Web.DynamicData;
  using System.Web.UI.WebControls;
  using DataModel;
  using Unleashed.DynamicData;

  public partial class Details : System.Web.UI.Page
  {
    protected UnleashedMetaTable ordersTable;
    protected UnleashedMetaTable itemsTable;

    protected void Page_Init(object sender, EventArgs e)
    {
      this.ordersTable = (UnleashedMetaTable)DynamicDataRouteHandler.GetRequestMetaTable(this.Context);
      this.Title = this.ordersTable.DisplayName;
      this.formDataSource.EntityTypeFilter = this.ordersTable.EntityType.Name;
      this.formDataSource.Include = this.ordersTable.ForeignKeyColumnsNames;

      this.itemsTable = (UnleashedMetaTable)Global.DefaultModel.GetTable(typeof(Order_Detail));
      this.gridView.SetMetaTable(this.itemsTable);
    }

    protected void GridDataSource_Selected(object sender, EntityDataSourceSelectedEventArgs e)
    {
      IEnumerable<Order_Detail> orderItems = e.Results.Cast<Order_Detail>(); 
      decimal totalAmount = orderItems.Sum(item => item.UnitPrice * item.Quantity);
      this.totalLiteral.Text = totalAmount.ToString();
    }

    protected void FormDataSource_QueryCreated(object sender, QueryCreatedEventArgs e)
    {
      e.Query = this.ordersTable.GetQueryable(e.Query);
    }
  }
}
