﻿namespace WebApplication.DynamicData.EntityTemplates
{
  using System;
  using System.Web.DynamicData;
  using FieldTemplates;

  public partial class CustomerEntityTemplate : EntityTemplateUserControl
  {
    protected override void OnDataBinding(EventArgs e)
    {
      base.OnDataBinding(e);
      this.UpdateRegionCountry();
    }

    protected void Country_FieldValueChanged(object source, EventArgs e)
    {
      this.UpdateRegionCountry();
    }

    private void UpdateRegionCountry()
    {
      var regionTemplate = this.regionControl.FieldTemplate as RegionEditField;
      if (regionTemplate != null)
        regionTemplate.Country = (string)this.countryControl.FieldValue;
    }
  }
}
