﻿using System;
using System.Collections.Specialized;
using System.Web.UI;
using Unleashed.DynamicData;

namespace WebApplication.DynamicData.FieldTemplates
{
  public partial class Boolean_EditField : UnleashedFieldTemplate
  {
    public override Control DataControl
    {
      get { return this.checkBox; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
      this.checkBox.ToolTip = this.Column.Description;
    }

    protected override void OnDataBinding(EventArgs e)
    {
      base.OnDataBinding(e);

      object val = this.FieldValue;
      if (val != null)
        this.checkBox.Checked = (bool)val;
    }

    protected override void ExtractValues(IOrderedDictionary dictionary)
    {
      dictionary[this.Column.Name] = this.checkBox.Checked;
    }
  }
}