﻿using System;
using System.Collections.Specialized;
using System.Web.UI;
using System.Web.UI.WebControls;
using Unleashed.DynamicData;

namespace WebApplication.DynamicData.FieldTemplates
{
  public partial class EnumerationEditField : UnleashedEnumerationFieldTemplate
  {
    public override Control DataControl
    {
      get { return this.dropDownList; }
    }

    protected override void OnLoad(EventArgs e)
    {
      this.dropDownList.ToolTip = this.Column.Description;

      if (this.dropDownList.Items.Count == 0)
      {
        if (this.Mode == DataBoundControlMode.Insert || !this.Column.IsRequired)
          this.dropDownList.Items.Add(new ListItem("[Not Set]", String.Empty));
        this.PopulateListControl(this.dropDownList);
      }

      this.SetUpValidator(this.requiredFieldValidator);
      this.SetUpValidator(this.dynamicValidator);
    }

    protected override void OnDataBinding(EventArgs e)
    {
      base.OnDataBinding(e);

      if (this.Mode == DataBoundControlMode.Edit && this.FieldValue != null)
      {
        string selectedValueString = this.GetSelectedValueString();
        ListItem item = this.dropDownList.Items.FindByValue(selectedValueString);
        if (item != null)
          this.dropDownList.SelectedValue = selectedValueString;
      }
    }

    protected override void ExtractValues(IOrderedDictionary dictionary)
    {
      string value = this.dropDownList.SelectedValue;
      if (value == string.Empty)
        value = null;
      dictionary[this.Column.Name] = this.ConvertEditedValue(value);
    }
  }
}