﻿using System.Web.UI;
using Unleashed.DynamicData;

namespace WebApplication.DynamicData.FieldTemplates
{
  public partial class ForeignKeyField : UnleashedFieldTemplate
  {
    public ForeignKeyField()
    {
      this.AllowNavigation = true;
    }

    public string NavigateUrl { get; set; }

    public bool AllowNavigation { get; set; }

    public override Control DataControl
    {
      get { return this.hyperLink; }
    }

    protected string GetDisplayString()
    {
      object value = this.FieldValue;
      if (value == null)
        return this.FormatFieldValue(this.ForeignKeyColumn.GetForeignKeyString(this.Row));
      return this.FormatFieldValue(this.ForeignKeyColumn.ParentTable.GetDisplayString(value));
    }

    protected string GetNavigateUrl()
    {
      if (!this.AllowNavigation)
        return null;

      if (string.IsNullOrEmpty(this.NavigateUrl))
        return this.ForeignKeyPath;
      return this.BuildForeignKeyPath(this.NavigateUrl);
    }
  }
}