﻿namespace WebApplication.DynamicData.FieldTemplates
{
  using System;
  using System.Web.DynamicData;
  using System.Web.UI;
  using Unleashed.DynamicData;

  public partial class ParentFieldTemplate : UnleashedFieldTemplate
  {
    private MetaForeignKeyColumn foreignKeyColumn;

    public override Control DataControl
    {
      get { return this.control.FieldTemplate.DataControl; }
    }

    public string DisplayField { get; set; }

    public string ForeignKeyField { get; set; }

    public new MetaForeignKeyColumn ForeignKeyColumn
    {
      get
      {
        if (this.foreignKeyColumn == null)
        {
          if (!string.IsNullOrEmpty(this.ForeignKeyField))
            this.foreignKeyColumn = (MetaForeignKeyColumn)this.Column.Table.GetColumn(this.ForeignKeyField);
          else
            this.foreignKeyColumn = base.ForeignKeyColumn;
        }

        return this.foreignKeyColumn;
      }
    }

    protected void Control_Init(object sender, EventArgs args)
    {
      this.container.SetMetaTable(this.ForeignKeyColumn.ParentTable);
      this.control.DataField = this.DisplayField;
    }

    protected override void OnDataBinding(EventArgs e)
    {
      object parentRow = DataBinder.GetPropertyValue(this.Row, this.ForeignKeyColumn.Name);
      this.container.DataItem = parentRow;
      base.OnDataBinding(e);
    }
  }
}