﻿namespace WebApplication.DynamicData.PageTemplates
{
  using System;
  using System.Web.DynamicData;
  using System.Web.Security;
  using System.Web.UI.WebControls;
  using Unleashed.DynamicData;

  public partial class Delete : System.Web.UI.Page
  {
    protected UnleashedMetaTable table;

    protected override void OnPreInit(EventArgs e)
    {
      base.OnPreInit(e);
      this.table = (UnleashedMetaTable)DynamicDataRouteHandler.GetRequestMetaTable(this.Context);
      if (!this.table.CanRead(this.User) || !this.table.CanDelete(this.User))
      {
        FormsAuthentication.RedirectToLoginPage();
        this.Response.End();
      }
    }

    protected override void OnInit(EventArgs e)
    {
      base.OnInit(e);
      this.dataSource.Include = this.table.ForeignKeyColumnsNames;
      this.dataSource.EntityTypeFilter = this.table.EntityType.Name;
      this.Title = this.table.DisplayName;
    }

    protected void FormView_ItemDeleted(object sender, FormViewDeletedEventArgs e)
    {
      if (e.Exception == null || e.ExceptionHandled)
        this.Response.Redirect(this.table.ListActionPath);
    }

    protected void DataSource_QueryCreated(object sender, QueryCreatedEventArgs e)
    {
      e.Query = this.table.GetQueryable(e.Query);
    }
  }
}