﻿using System;
using System.Web.DynamicData;
using System.Web.UI.WebControls;
using System.Web.Security;

namespace WebApplication.DynamicData.PageTemplates
{
  public partial class Insert : System.Web.UI.Page
  {
    protected MetaTable table;

    protected override void OnPreInit(EventArgs e)
    {
      base.OnPreInit(e);
      this.table = DynamicDataRouteHandler.GetRequestMetaTable(this.Context);
      if (!this.table.CanInsert(this.User))
      {
        FormsAuthentication.RedirectToLoginPage();
        this.Response.End();
      }
    }

    protected override void OnInit(EventArgs e)
    {
      base.OnInit(e);
      this.Title = this.table.DisplayName;
      this.dataSource.EntityTypeFilter = this.table.EntityType.Name;
      this.formView.SetMetaTable(this.table, this.table.GetColumnValuesFromRoute(this.Context));
    }

    protected void FormView_ItemCommand(object sender, FormViewCommandEventArgs e)
    {
      if (e.CommandName == DataControlCommands.CancelCommandName)
        this.Response.Redirect(this.table.ListActionPath);
    }

    protected void FormView_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
      if (e.Exception == null || e.ExceptionHandled)
        this.Response.Redirect(this.table.ListActionPath);
    }
  }
}
