﻿<%@ Page Language="C#" MasterPageFile="~/Site.master" CodeBehind="List.aspx.cs" Inherits="WebApplication.DynamicData.PageTemplates.List" %>
<%@ Register Src="~/DynamicData/Content/GridViewPager.ascx" TagName="GridViewPager" TagPrefix="dd" %>
<asp:Content ContentPlaceHolderID="main" runat="Server">
  <asp:DynamicDataManager runat="server">
    <DataControls>
      <asp:DataControlReference ControlID="gridView" />
    </DataControls>
  </asp:DynamicDataManager>

  <h2><%= this.table.DisplayName%></h2>

  <asp:UpdatePanel runat="server">
    <ContentTemplate>
      <div class="DD">
        <asp:ValidationSummary runat="server" HeaderText="List of validation errors" />
        <unl:UnleashedValidator runat="server" ControlToValidate="gridView" Display="None" />

        <unl:UnleashedFilterRepeater runat="server" ID="FilterRepeater">
          <ItemTemplate>
            <asp:Label runat="server" Text='<%# Eval("DisplayName") %>' OnPreRender="Label_PreRender" />
            <unl:UnleashedFilter runat="server" ID="DynamicFilter" OnFilterChanged="DynamicFilter_FilterChanged" />
            <br />
          </ItemTemplate>
        </unl:UnleashedFilterRepeater>
        <br />
      </div>

      <asp:GridView ID="gridView" runat="server" DataSourceID="dataSource" EnablePersistedSelection="false" AllowPaging="True" AllowSorting="True">
        <Columns>
          <asp:TemplateField>
            <ItemTemplate>
              <asp:DynamicHyperLink runat="server" Action="Edit" Text="Edit" OnInit="EditLink_Init" />
              <asp:DynamicHyperLink runat="server" Action="Delete" Text="Delete" OnInit="DeleteLink_Init" />
              <asp:DynamicHyperLink runat="server" Text="Details" />
            </ItemTemplate>
          </asp:TemplateField>
        </Columns>
        <PagerTemplate>
          <dd:GridViewPager runat="server" />
        </PagerTemplate>
      </asp:GridView>
      
      <div class="DDBottomHyperLink">
        <asp:DynamicHyperLink ID="insertLink" runat="server" OnInit="InsertLink_Init">
          <img runat="server" src="~/DynamicData/Content/Images/plus.gif" alt="Insert new item" />
          Insert new item
        </asp:DynamicHyperLink>
      </div>

      <asp:EntityDataSource ID="dataSource" runat="server" EnableFlattening="false" OnQueryCreated="DataSource_QueryCreated"/>
      <asp:QueryExtender TargetControlID="dataSource" runat="server">
        <unl:UnleashedFilterExpression ControlID="FilterRepeater" />
      </asp:QueryExtender>
    </ContentTemplate>
  </asp:UpdatePanel>
</asp:Content>
