﻿<%@ Page Language="C#" MasterPageFile="~/Site.master" CodeBehind="ListDetails.aspx.cs"
  Inherits="WebApplication.DynamicData.PageTemplates.ListDetails" %>

<%@ Register Src="~/DynamicData/Content/GridViewPager.ascx" 
  TagName="GridViewPager" TagPrefix="dd" %>

<asp:Content ContentPlaceHolderID="main" runat="Server">
  <asp:DynamicDataManager runat="server" AutoLoadForeignKeys="true">
    <DataControls>
      <asp:DataControlReference ControlID="formView" />
      <asp:DataControlReference ControlID="gridView" />
    </DataControls>
  </asp:DynamicDataManager>

  <h2><%= table.DisplayName %></h2>

  <asp:UpdatePanel runat="server">
    <ContentTemplate>
      <div class="DD">
        <asp:ValidationSummary runat="server" HeaderText="List of validation errors" />
        <unl:UnleashedValidator runat="server" ControlToValidate="gridView" Display="None" />
        <unl:UnleashedValidator runat="server" ControlToValidate="formView" Display="None" />

        <unl:UnleashedFilterRepeater runat="server" ID="filterRepeater">
          <ItemTemplate>
            <asp:Label runat="server" Text='<%# Eval("DisplayName") %>' OnPreRender="Label_PreRender" />
            <unl:UnleashedFilter runat="server" ID="DynamicFilter" OnFilterChanged="DynamicFilter_FilterChanged" />
            <br />
          </ItemTemplate>
        </unl:UnleashedFilterRepeater>
        <br />
      </div>

      <asp:GridView ID="gridView" runat="server" DataSourceID="gridDataSource" EnablePersistedSelection="true"
        AutoGenerateSelectButton="True" AutoGenerateEditButton="True" AutoGenerateDeleteButton="true"
        AllowPaging="True" AllowSorting="True" OnDataBound="GridView_DataBound" OnRowEditing="GridView_RowEditing"
        OnSelectedIndexChanging="GridView_SelectedIndexChanging" OnRowDeleted="DataBindFormView"
        OnRowUpdated="DataBindFormView" OnRowCreated="GridView_RowCreated">
        <PagerTemplate>
          <dd:GridViewPager runat="server" />
        </PagerTemplate>
      </asp:GridView>

      <asp:EntityDataSource ID="gridDataSource" runat="server" EnableDelete="true" EnableUpdate="true" />
      <asp:QueryExtender TargetControlID="gridDataSource" runat="server">
        <unl:UnleashedFilterExpression ControlID="filterRepeater" />
      </asp:QueryExtender>

      <asp:Panel ID="DetailsPanel" runat="server">
        <br />
        <br />
        <asp:FormView ID="formView" runat="server" DataSourceID="formDataSource"
          OnPreRender="FormView_PreRender" OnModeChanging="FormView_ModeChanging" OnItemUpdated="DataBindGridView"
          OnItemInserted="DataBindGridView" OnItemDeleted="DataBindGridView">
          <ItemTemplate>
            <asp:DynamicEntity runat="server" />
            <tr>
              <td colspan="2">
                <asp:LinkButton runat="server" CommandName="Edit" Text="Edit" />
                <asp:LinkButton runat="server" CommandName="Delete" Text="Delete" />
                <asp:LinkButton runat="server" CommandName="New" Text="New" />
              </td>
            </tr>
          </ItemTemplate>
          <EditItemTemplate>
            <asp:DynamicEntity runat="server" Mode="Edit" />
            <tr>
              <td colspan="2">
                <asp:LinkButton runat="server" CommandName="Update" Text="Update" />
                <asp:LinkButton runat="server" CommandName="Cancel" Text="Cancel" CausesValidation="false" />
              </td>
            </tr>
          </EditItemTemplate>
          <InsertItemTemplate>
            <asp:DynamicEntity runat="server" Mode="Insert" />
            <tr>
              <td colspan="2">
                <asp:LinkButton runat="server" CommandName="Insert" Text="Insert" />
                <asp:LinkButton runat="server" CommandName="Cancel" Text="Cancel" CausesValidation="false" />
              </td>
            </tr>
          </InsertItemTemplate>
        </asp:FormView>
        <asp:EntityDataSource ID="formDataSource" runat="server" EnableDelete="true" EnableInsert="true"
          EnableUpdate="true" />
        <asp:QueryExtender TargetControlID="formDataSource" runat="server">
          <asp:ControlFilterExpression ControlID="gridView" />
        </asp:QueryExtender>
      </asp:Panel>
    </ContentTemplate>
  </asp:UpdatePanel>
</asp:Content>
