﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.DynamicData;
using System.Reflection;

namespace WebApplication.MetaDataExplorer
{
  public partial class MetaColumnPage : System.Web.UI.Page
  {
    protected MetaTable table;
    protected MetaColumn column;

    protected override void OnInit(EventArgs e)
    {
      base.OnInit(e);
      this.table = MetaModel.Default.GetTable(this.Request["Table"]);
      this.column = this.table.GetColumn(this.Request["Column"]);      
    }

    protected override void OnLoad(EventArgs e)
    {
      base.OnLoad(e);
      if (!this.IsPostBack)
      {
        MetaDataExplorer.DisplayObjectDetails(this.column, this.columnDetails);

        this.attributeGrid.DataSource = this.column.Attributes.Cast<Attribute>().Select(a => a.GetType());
        this.attributeGrid.DataBind();
      }
    }

    protected void AttributeGrid_RowCommand(object sender, GridViewCommandEventArgs e)
    {
      if (e.CommandName == "Attribute")
      {
        int attributeIndex = int.Parse((string)e.CommandArgument);
        Attribute attribute = this.column.Attributes[attributeIndex];
        MetaDataExplorer.DisplayObjectDetails(attribute, this.attributeDetails);
      }
    }

    protected void ColumnDetails_ItemCommand(object sender, DetailsViewCommandEventArgs e)
    {
      if (e.CommandName == "DataTypeAttribute")
      {
        MetaDataExplorer.DisplayObjectDetails(this.column.DataTypeAttribute, this.attributeDetails);
      }
    }
  }
}