﻿using System;
using System.Linq;
using System.Web.DynamicData;
using DataModel;

namespace WebApplication.Samples.Ch09.EntityMethod
{
  public partial class SamplePage : System.Web.UI.Page
  {
    protected MetaTable ordersTable;

    protected void Page_Init(object sender, EventArgs e)
    {
      this.ordersTable = MetaModel.Default.GetTable(typeof(Order));
      this.formView.SetMetaTable(this.ordersTable);
      this.dataSource.Include = this.ordersTable.ForeignKeyColumnsNames;
    }

    protected void FulfillButton_Click(object sender, EventArgs args)
    {
      using (var context = new NorthwindEntities())
      {
        int orderId = (int)this.formView.DataKey.Value;
        Order order = context.Orders.First(o => o.OrderID == orderId);
        order.Fulfill();
        context.SaveChanges();
        this.Response.Redirect(this.ordersTable.GetActionPath(PageAction.Details, order));
      }
    }
  }
}