﻿using System;
using System.Collections.Generic;
using System.Web.DynamicData;
using DataModel;

namespace WebApplication.Samples.Ch09.ValidationAndErrorHandling
{
  public partial class SamplePage : System.Web.UI.Page
  {
    protected MetaTable ordersTable;

    protected void Page_Init(object sender, EventArgs e)
    {
      this.ordersTable = MetaModel.Default.GetTable(typeof(Order));
      this.formView.SetMetaTable(this.ordersTable);
      this.dataSource.Include = this.ordersTable.ForeignKeyColumnsNames;
    }

    protected void FulfillButton_Click(object sender, EventArgs args)
    {
      using (var context = new NorthwindEntities())
      try
      {
        int orderId = (int)this.formView.DataKey.Value;
        context.FulfillOrder(orderId);
        context.SaveChanges();
        this.Response.Redirect(this.ordersTable.GetActionPath(PageAction.Details, new List<object>(new object[] { orderId })));
      }
      catch (Exception e)
      {
        if (!this.validator.HandleException(e)) throw;
      }
    }
  }
}