﻿namespace WebApplication
{
  using System;
  using System.Web;
  using System.Web.DynamicData;
  using System.Web.UI;
  using System.Web.UI.WebControls;

  public partial class Site : MasterPage
  {
    protected void MetadataHyperLink_Init(object sender, EventArgs e)
    {
      var link = (HyperLink)sender;
      MetaTable table = DynamicDataRouteHandler.GetRequestMetaTable(this.Context);
      if (table != null)
        link.NavigateUrl = "~/MetaDataExplorer/MetaTable.aspx?Name=" + table.Name;
      else
        link.NavigateUrl = "~/MetaDataExplorer/MetaModel.aspx";
    }

    protected void RoleLabel_Init(object sender, EventArgs e)
    {
      var label = (Label)sender;
      var roles = new[] {"Manager", "Employee", "Customer"};
      foreach (string role in roles)
      {
        if (HttpContext.Current.User.IsInRole(role))
        {
          label.Text = role;
          return;
        }
      }
    }
  }
}